PROGRAM cap7_4
IMPLICIT NONE
CHARACTER (LEN=15), DIMENSION (5) :: nomb
CHARACTER (LEN=15)::nombm,nombp
REAL, DIMENSION(5) :: nota
REAL:: mejor,peor,mediaclase,media
INTEGER:: i,n,error_de_apertura,error_de_lectura,suficientes,num

OPEN (10,FILE='cap7_4in.txt',STATUS='OLD',ACTION='READ',&
IOSTAT=error_de_apertura)
IF (error_de_apertura>0) STOP 'cap7_4in.txt NO ABIERTO'

!..LECTURA DE DATOS.
i=1
DO
  READ(10,*,IOSTAT=error_de_lectura) nomb(i),nota(i)
  externo:IF (error_de_lectura >0 ) THEN
    WRITE(*,*) 'error de lectura'
    EXIT
  ELSE IF (error_de_lectura <0 ) THEN
!    WRITE(*,*) 'fin del archivo'
    n=i-1
    EXIT
  ENDIF
  i=i+1
END DO    
!..CALCULO DEL PEOR DE LA CLASE..
peor=nota(1)
nombp=nomb(1)
DO i=2,n
  IF (nota(i) < peor) THEN
    peor=nota(i)
    nombp=nomb(i)
  END IF
END DO
!..CALCULO DEL MEJOR DE LA CLASE..
mejor=nota(1)
nombm=nomb(1)
DO i=2,n
  IF (nota(i) > mejor) THEN
    mejor=nota(i)
    nombm=nomb(i)
  END IF
END DO
num=suficientes(nota,n)
media=mediaclase(nota,n)

!ESCRITURA DE RESULTADOS EN UN ARCHIVO

OPEN (20,FILE='cap7_4out.txt',STATUS='NEW',ACTION='WRITE',&
IOSTAT=error_de_apertura)
IF (error_de_apertura>0) STOP 'cap7_4out.txt NO ABIERTO'
WRITE(20,'(1X,A,I3,A)') 'HAY',num,' ALUMNOS CON SUFICIENTE'
WRITE(20,'(1X,A,F4.1)') 'LA NOTA MEDIA DE LA CLASE ES:',media
WRITE(20,'(1X,3A,F4.1)') 'El peor alumno es: ',nombp,'y su nota es:',peor
WRITE(20,'(1X,3A,F4.1)') 'El mejor alumno es: ',nombm, 'y su nota es:',mejor
CLOSE (10)
CLOSE (20)
END PROGRAM cap7_4
 
!..ALUMNOS QUE HAN SACADO SUFICIENTE..
 
INTEGER FUNCTION suficientes(nota,n)
IMPLICIT NONE 
INTEGER, INTENT(IN) :: n
REAL, DIMENSION(n),INTENT(IN) :: nota
INTEGER :: contador,i
contador=0
DO i=1,n
  IF (nota(i) >= 5.AND.nota(i) < 6) THEN
    contador=contador+1
  END IF
END DO
suficientes=contador
END FUNCTION suficientes
 
!..CALCULO DE LA MEDIA DE LA CLASE..
 
REAL FUNCTION mediaclase(nota,n)
IMPLICIT NONE
INTEGER, INTENT(IN) :: n 
REAL, DIMENSION(n), INTENT(IN) :: nota
INTEGER:: i
mediaclase=0
DO  i=1,n
  mediaclase=mediaclase+nota(i)
END DO
mediaclase=mediaclase/n
END FUNCTION mediaclase
 
